//-----------------------------------------------------------------
// SX15-Evo e scheda FLEX Analog - Firmware di test
// Versione : 1.0
// Area SX
// http://www.areasx.com
// Note     : per utilizzare il firmware  necessario impostare
//           sul dip switch S3 gli interruttore 5:ON e 7:ON
//          Sulla scheda FLEX devono essere impostate le seguenti 
//          configurazioni dei ponticelli:
//          S2 : A1 aperto, A2 chiuso
//          JP6: A0, A1 ed A2 chiusi
//-----------------------------------------------------------------
// -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
// ATTENZIONE!!!!:
// -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
// La libreria di Rabbit I2C.LIB, contenuta nella sottocartella Lib/I2C
// del compilatore Dynamic C contiene un errore nella funzione
// i2c_init(). In pratica anche definendo una diversa porta per l'i2c
// tramite i #define i2c_SCL_H() e seguenti, il port D viene comunque
// inizializzato, impedendo il corretto funzionamento della scheda.
// Per correggere l'errore  possibile effettuare nel file i2c.lib
// la modifica sotto riportata:
//
// Nella parte appena precedente la funzione i2c_init():
//
// // Define these to change basic bit handling
// #ifndef i2c_SCL_H()
// #define i2c_SCL_H() BitWrPortI(PDDDR,&PDDDRShadow,0,I2CSCLBit)
// #define i2c_SCL_L() BitWrPortI(PDDDR,&PDDDRShadow,1,I2CSCLBit)
// #define i2c_SDA_H() BitWrPortI(PDDDR,&PDDDRShadow,0,I2CSDABit)
// #define i2c_SDA_L() BitWrPortI(PDDDR,&PDDDRShadow,1,I2CSDABit)
// #define i2c_SCL()   BitRdPortI(PDDR,I2CSCLBit)
// #define i2c_SDA()   BitRdPortI(PDDR,I2CSDABit)
// #define I2C_DOINIT                   <<<----- AGGIUNGERE QUESTA RIGA!
// #endif
//
// Nella funzione i2c_init():
//
// void i2c_init()
// {
//
// #ifdef I2C_DOINIT                    <<<----- AGGIUNGERE QUESTA RIGA!
//
//  // Set the bits to tristate and the output to 0. Toggle using
//  //tristate reg.
//
// 	// This function affects the port D transfer transfer clock
// 	// Transfer clock on port D is PCLK/2
//
// 	WrPortI(PDCR,&PDCRShadow,0);
// 	BitWrPortI(PDFR ,&PDFRShadow ,0,I2CSCLBit);
// 	// Set the bits to normal function
// 	BitWrPortI(PDFR ,&PDFRShadow ,0,I2CSDABit);
// 	BitWrPortI(PDDDR,&PDDDRShadow,0,I2CSCLBit);
// 	// Set the bits to input (=0)
// 	BitWrPortI(PDDDR,&PDDDRShadow,0,I2CSDABit);
// 	BitWrPortI(PDDCR,&PDDCRShadow,1,I2CSCLBit);
// 	// Set the bits to Open Drain
// 	BitWrPortI(PDDCR,&PDDCRShadow,1,I2CSDABit);
// 	BitWrPortI(PDDR ,&PDDRShadow ,0,I2CSCLBit);
// 	// Set the outputs to 0, when outputs
// 	BitWrPortI(PDDR ,&PDDRShadow ,0,I2CSDABit);
//
// #endif                               <<<----- AGGIUNGERE QUESTA RIGA!
//
// 	i2c_clocks_per_us = (int)(19200L*32*freq_divider/1000000L);
// 	if(i2c_clocks_per_us < 3)
// 	{
// 		i2c_clocks_per_us = 3;
// 	}
// }
//
// Con la modifica sopra esposta il port D viene correttamente
// rilasciato per poter essere utilizzato dalla lettura ingressi.
//-----------------------------------------------------------------
//-----------------------------------------------------------------



//-----------------------------------------------------------------
// Configurazione Firmware
//-----------------------------------------------------------------
#define DEBUG_INFO


//-----------------------------------------------------------------
// Define Hardware
//-----------------------------------------------------------------
#define LEDLD1_ON       BitWrPortI(PFDR,&PFDRShadow,1,1)
#define LEDLD1_OFF      BitWrPortI(PFDR,&PFDRShadow,0,1)
#define LEDLD2_ON       BitWrPortI(PFDR,&PFDRShadow,1,0)
#define LEDLD2_OFF      BitWrPortI(PFDR,&PFDRShadow,0,0)
#define LEDLD3_ON       BitWrPortI(PFDR,&PFDRShadow,1,4)
#define LEDLD3_OFF      BitWrPortI(PFDR,&PFDRShadow,0,4)
#define BUTTON_PRESS    BitRdPortI(PEDR,1)

// Output channel
#define STROBE        BitWrPortI(PBDR,&PBDRShadow,1,5);BitWrPortI(PBDR,&PBDRShadow,0,5)
#define CLOCK         BitWrPortI(PBDR,&PFDRShadow,1,4);BitWrPortI(PBDR,&PFDRShadow,0,4)
#define SET_DATA      BitWrPortI(PBDR,&PFDRShadow,1,7)
#define CLEAR_DATA    BitWrPortI(PBDR,&PFDRShadow,0,7)

// Input channel
#define INP_LOADHI    BitWrPortI(PBDR,&PBDRShadow,1,3)
#define INP_LOADLO    BitWrPortI(PBDR,&PBDRShadow,0,3)
#define INP_CLOCKHI   BitWrPortI(PBDR,&PBDRShadow,1,0)
#define INP_CLOCKLO   BitWrPortI(PBDR,&PBDRShadow,0,0)
#define INP_DATA      BitRdPortI(PBDR,2)

#define I2CSCLBit 5       //Linea di clock PD5
#define I2CSDABit 4       //Linea Data PD4

// Sposta il port dell'I2C sul PortD
#define i2c_SCL_H() BitWrPortI(PDDDR,&PDDDRShadow,0,I2CSCLBit)
#define i2c_SCL_L() BitWrPortI(PDDDR,&PDDDRShadow,1,I2CSCLBit)
#define i2c_SDA_H() BitWrPortI(PDDDR,&PDDDRShadow,0,I2CSDABit)
#define i2c_SDA_L() BitWrPortI(PDDDR,&PDDDRShadow,1,I2CSDABit)
#define i2c_SCL()   BitRdPortI(PDDR,I2CSCLBit)
#define i2c_SDA()   BitRdPortI(PDDR,I2CSDABit)

#define DS1621_ADDRESS 0x00       // Indirizzo del sensore di temperatura
#define AD1_ADDRESS    0x02       // Indirizzo AD1
#define AD2_ADDRESS    0x03       // Indirizzo AD2

#define COSTANTE (float)  5/255

// -----------------------------------------------------------------------
// Librerie
// -----------------------------------------------------------------------
#use "I2C.LIB"



//-----------------------------------------------------------------
// Globali
//-----------------------------------------------------------------
char tmpbuf[1024];          // Buffer temporaneo

//-----------------------------------------------------------------
// Prototipi
//-----------------------------------------------------------------
void BoardInit(void);
nodebug void msDelay(unsigned int );
float DS1621Read(unsigned char);
int DS1621Init(unsigned char);

//-----------------------------------------------------------------
// General purpose delay routine
//-----------------------------------------------------------------
nodebug void msDelay(unsigned int delay) {
  auto unsigned long tt;
  tt=MS_TIMER;
  while (MS_TIMER<delay+tt) ;

}

//--------------------------------------------------------
// Inizializza i port del modulo RCM3700
// Riceve      : -
// Restituisce : -
// Note        :
//--------------------------------------------------------
void BoardInit() {

  // Port A
  // Default ingresso

  // Port B
  // PB0 - ICL (output)
  BitWrPortI(PBDDR,&PBDDRShadow,1,0);
  // PB2 - IDA (input)
  // PB3 - IPL (output)
  BitWrPortI(PBDDR,&PBDDRShadow,1,3);
  // PB4 - OCL (output)
  BitWrPortI(PBDDR,&PBDDRShadow,1,4);
  // PB5 - STR (output)
  BitWrPortI(PBDDR,&PBDDRShadow,1,5);
  // PB7 - ODA (output)
  BitWrPortI(PBDDR,&PBDDRShadow,1,7);

  // Port C
  // PC0-PC1 - Seriale D
  BitWrPortI(PCFR, &PCFRShadow, 1,0);

  // PC2-PC3 - Seriale C
  // Modem GSM
  BitWrPortI(PCFR, &PCFRShadow, 1,2);

  // Port D
  // PD4 - I2C SDA
  BitWrPortI(PDDDR, &PDDDRShadow, 0, I2CSDABit);
  BitWrPortI(PDDR,&PDDRShadow,0,I2CSDABit);
  // PD5 - I2C SCL
  BitWrPortI(PDDDR, &PDDDRShadow, 0, I2CSCLBit);
  BitWrPortI(PDDR,&PDDRShadow,0,I2CSCLBit);

  // Port E
  WrPortI(PEFR, &PEFRShadow, 0x00);
  // PE0 - DCD Modem GSM (ingresso)
  // PE1 - Pulsante esterno (ingresso)
  // PE4 - GSM Power Control (ingresso)
  // PE5 - RS485 Data Direction / RS232 DTR (output)
  BitWrPortI(PEDDR, &PEDDRShadow, 1,5);
  // PE7 - GSM On/Off (output)
  BitWrPortI(PEDDR, &PEDDRShadow, 1,7);

  // Port F
  WrPortI(PFFR, &PFFRShadow, 0x00);
  WrPortI(PFDCR, &PFDCRShadow, 0x00);
  // PF0 - Led LD3 (output)
  BitWrPortI(PFDDR, &PFDDRShadow, 1,0);
  // PF1 - Led LD1 (output)
  BitWrPortI(PFDDR, &PFDDRShadow, 1,1);
  // PF4 - Led LD2 (output)
  BitWrPortI(PFDDR, &PFDDRShadow, 1,4);
  // PF5 - Modem Reset (output)
  BitWrPortI(PFDDR, &PFDDRShadow, 1,5);
  // PF6 - SH71 External I2c (bid)
  // PF7 - SH71 External I2c (bid)

  // Port G
  WrPortI(PGFR, &PGFRShadow, 0x00);
  // PG6-PG7 - Seriale E (RF Transmitter, Caller Id, GPS Receiver)
  BitWrPortI(PGFR, &PGFRShadow, 1,6);
  BitWrPortI(PGDDR, &PGDDRShadow, 0,7);
  BitWrPortI(PGDDR, &PGDDRShadow, 1,6);

  // Inizializzazione libreria I2C
  i2c_init();

  // Inizializzazione del sensore di temperatura
  DS1621Init(DS1621_ADDRESS);
  
}


// -----------------------------------------------------------------------
// Inizializzazione del sensore di temperatura
// Riceve     : address: indirizzo I2C del sensore
// Restituisce: 1 se tutto OK, <=0 se ci sono errori
// -----------------------------------------------------------------------
int DS1621Init(unsigned char address){

  i2c_stop_tx();

  // Invia lo start
  if (i2c_startw_tx()){
    i2c_stop_tx();
    return -1;
  }

  // Indirizza il chip e attende la risposta
  if (i2c_wr_wait(0x90 + (address<<1))){
    i2c_stop_tx();
    return -2;
  }

  // Parametri di configurazione del DS1621

  // Invia il comando ACh (Access Config)
  if (i2c_write_char(0xAC)){
    i2c_stop_tx();
    return -3;
  }

  // Invia il Dato 02h
  if (i2c_write_char(0x2)){
    i2c_stop_tx();
    return -4;
  }

  // Invia lo start di sincronismo
  if (i2c_startw_tx()) {
    i2c_stop_tx();
    return -5;
  }

  // Indirizza il chip e attende la risposta
  if (i2c_wr_wait(0x90 + (address<<1))) {
    i2c_stop_tx();
    return -6;
  }

  // Invia il comando EEh che avvia le conversioni
  if (i2c_write_char(0xEE)){
    i2c_stop_tx();
    return -7;
  }

  // Chiusura
  i2c_stop_tx();
  return 1;

}


// -----------------------------------------------------------------------
// Funzione di lettura temperatura dal DS1621
// Riceve     : address - Indirizzo I2C
// Restituisce: valore di temperatura letto (float) se tutto OK, un valore
//              <-100 se errore
// -----------------------------------------------------------------------
float DS1621Read(unsigned char address) {

  auto unsigned char cnt;
  auto float temp;

  i2c_stop_tx();
  // Invia lo start di sincronismo
  if (i2c_startw_tx()) {
    i2c_stop_tx();
    return -101;
  }
  // Indirizza il chip
  if (i2c_wr_wait(0x90 + (address<<1))) {
    i2c_stop_tx();
    return -102;
  }
  // Invia il comando AAh (lettura dell'ultima temperatura campionata)
  if (i2c_write_char(0xAA)){
    i2c_stop_tx();
    return -103;
  }
  // Invia lo start di sincronismo
  if (i2c_startw_tx()) {
    i2c_stop_tx();
    return -104;
  }
  // Indirizzo  + linea RW/R a 1
  if (i2c_wr_wait(0x90 + (address<<1) + 1)){
    i2c_stop_tx();
    return -105;
  }

  for (cnt=0;cnt<2;cnt++)
  {
    if (i2c_read_char(&tmpbuf[cnt])){
      i2c_stop_tx();
      return -106;
    }
    if (cnt==1){
      i2c_send_nak();
    } else {
      i2c_send_ack();
    }
  }

  // Tutto Ok
  i2c_stop_tx();

  // Converto in float
  temp=0;
  // Imposto il mezzo grado
  if (tmpbuf[1]==0x80) temp=0.5;

  if (tmpbuf[0] & 0x80) {
    // Temperatura negativa
    temp+=(!tmpbuf[0])+1;
    temp=-temp;
  } else {
    // Temperatura >0
    temp+=tmpbuf[0];
  }

  return (temp);
}



// -----------------------------------------------------------------------
// Lettura dei canali AD
// Riceve      : -
// Restituisce : -
// Note        :
// -----------------------------------------------------------------------
int read_PCF8591(unsigned char address, char *buf, unsigned char len) {

  	auto unsigned char cnt;
  	auto short int err;

  	i2c_stop_tx();  //ferma il chip

  	// Invia lo START
  	if (err=i2c_startw_tx()){
   	 i2c_stop_tx();
   	 return -10;   //ritorna il codice di errore -10
  	}

  	// Scrive l'indirizzo I2C e attende la risposta ACK dal dispositivo
  	if (err=i2c_wr_wait(0x90 | (address<<1))){
   	 i2c_stop_tx();
   	 return -20;   //ritorna il codice di errore -20
  	}

  	// Parametri di configurazione del PCF8591 (Vedi datasheet)

  	//Invia il comando di configurazione
  	if (err=i2c_write_char(0x44)){
    	i2c_stop_tx();
    	return -30;   //ritorna il codice di errore -30
  	}

  	// Stop
   i2c_stop_tx();

  // Ciclo di lettura
  //invia lo start di sincronismo
  if (err=i2c_startw_tx()) {
    i2c_stop_tx();
    return -10;   //ritorna il codice di errore -10
  }


  // Invia l'indirizzo  + linea RW/R a 1
  	if (err=i2c_wr_wait(0x91 | (address<<1))){
		i2c_stop_tx();
		return -70;
  	}

  	// Effettua una prima lettura
	i2c_read_char(&buf[cnt]);
	i2c_send_ack();

	//Ciclo di lettura degli n byte
  	for (cnt=0;cnt<len;cnt++) {
		err=i2c_read_char(&buf[cnt]);
		if (err){
      	i2c_stop_tx();
	      return -80;
   	}

    	if (cnt==(len-1)){
      	i2c_send_nak();
	   } else {
      	i2c_send_ack();
    	}
	}

  // Stop
  i2c_stop_tx();

  return 1;
}




//-----------------------------------------------------------------
//-----------------------------------------------------------------
//    MAIN
//-----------------------------------------------------------------
//-----------------------------------------------------------------
main () {
  int i;
  char read_volt[4];
  float Temperature;

  // Inizializzazione Scheda
  BoardInit();


  #ifdef DEBUG_INFO
    printf ("SX15-Evo: System Ready\n");
  #endif


  while (1) {

    msDelay(2000);

    printf ("LETTURA TEMPERATURA (U3) -----------\n");
    Temperature=DS1621Read(DS1621_ADDRESS);
    printf ("Temperatura [%.1f]\n",Temperature);
    printf ("----------------------------------\n\n");


    printf ("LETTURA AD1 (U2) --------------------\n");
    if(read_PCF8591(AD1_ADDRESS,read_volt,4) < 1) {
      // Segnala eventuali errori di lettura
      printf("-> Errore AD\n");
		} else {
		  	// Visualizza i valori letti
	   	for (i=0;i<4;i++) {
      		printf("Lettura Ch %d [%03d]:  V%.2f\n", i, read_volt[i], (read_volt[i] * COSTANTE));
	   	}
		}
    printf ("\nLETTURA AD2 (U1) --------------------\n");
    if(read_PCF8591(AD2_ADDRESS,read_volt,4) < 1) {
      // Segnala eventuali errori di lettura
      printf("-> Errore AD\n");
		} else {
		  	// Visualizza i valori letti
	   	for (i=0;i<4;i++) {
      		printf("Lettura Ch %d [%03d]:  V%.2f\n", i, read_volt[i], (read_volt[i] * COSTANTE));
	   	}
		}
    printf("----------------------------------\n\n");

  }

}